# !/usr/bin/python
# -*- coding: <UTF-8> -*-

"""
Python Version : 3.6

$LastChangedRevision: 5784 $
$LastChangedDate:: 2022-04-21 10:13:47 +0200#$

This file is part of SyMSpace.

Copyright (c) 2020, Linz Center of Mechatronics GmbH (LCM) http://www.lcm.at/
All rights reserved.
"""
import os
import shutil
from symspace.wrapper.symwrapper import SymProject
import componentspace.osutils.fileutils as fu
from symspace.osutils.pathutils import Paths
from componentspace.base_component import Component


class HerokuComponent(Component):

    def __init__(self, comp_file=None):
        super().__init__(comp_file)

    def createComponent(self, template: str = None, component_data: dict = None) -> str:
        if template is None:
            template = os.path.join(Paths.getComponentSpaceRoot(), 'KnowledgeEngines', 'Heroku', '_template')

        file_name = super(HerokuComponent, self).createComponent(template, component_data)

        heroku_app_name = 'symspace-{}'.format(self.name).lower()
        for pattern in (' ', '_'):
            heroku_app_name.replace(pattern, '-')
        server_uri = '{}.herokuapp.com'.format(heroku_app_name)

        # self.sym_mdl = SymProject.load(os.path.join(self.path, self.name))
        # fnc_heroku_client = self.sym_mdl['Project.HerokuClient']  # type: SymContainer
        fnc_heroku_client_py = os.path.join(self.path, 'src', 'fnc_herokuclient.py')

        # fnc_heroku_client_cls = 'FncHerokuClient'
        # # fnc_heroku_client.convertToPythonFunction(fnc_heroku_client_py, fnc_heroku_client_cls)
        # self.sym_mdl['Project.HerokuClient.serverURI'].setData(str(server_uri))

        src_server_file = os.path.join(Paths.getComponentSpaceRoot(), 'src', 'packages', 'open_webservice', 'heroku',
                                       'server.py')
        dst_server_file = os.path.join(self.path, 'resources', 'heroku_server', 'heroku_server.py')
        heroku_create_bat = os.path.join(self.path, 'resources', 'heroku_create_app.bat')
        heroku_destroy_bat = os.path.join(self.path, 'resources', 'heroku_destroy_app.bat')

        shutil.copy2(src_server_file, dst_server_file)
        fu.replaceInFile(fnc_heroku_client_py, '__server_uri__', server_uri)
        fu.replaceInFile(heroku_create_bat, '__appname__', heroku_app_name)
        fu.replaceInFile(heroku_destroy_bat, '__appname__', heroku_app_name)

        # self.sym_mdl.save()
        return file_name
