#!/usr/bin/python
# -*- coding: <UTF-8> -*-

"""
Python Version : 3.6

$LastChangedRevision: 4056 $
$LastChangedDate:: 2021-02-04 14:01:11 +0100#$

This file is part of SyMSpace.

Copyright (c) 2018, Linz Center of Mechatronics GmbH (LCM) http://www.lcm.at/
All rights reserved.
"""
import os
import optparse
from symspace.osutils.pathutils import Paths
from symspace.osutils.pathutils import CMDParser
from lcm.testing.nose_testrunner import NoseTestRunner as GeneralNoseTestRunner


class NoseTestRunner(GeneralNoseTestRunner):
    """
    Tests all Python tests found in path and all it's subdirectories using the nose framework

    - writes xunit xml-files with testresults
    - writes coverage xml-files for selected packages

    """
    @staticmethod
    def getDefaultDirs() -> tuple:
        src_path = os.path.join(Paths.getComponentSpaceRoot(), 'src')
        start_dir = os.path.join(src_path, 'tests')
        reports_dir = os.path.join(Paths.getCSTestReportsDir(), 'packages')
        cov_dir = os.path.join(src_path, 'packages')
        return start_dir, reports_dir, cov_dir

    @staticmethod
    def parseCMD(parser: optparse.OptionParser) -> tuple:
        args = CMDParser.jepSysArgs()
        (options, args) = parser.parse_args(args)

        start_dir = CMDParser.jepArgPath(options.start_dir)
        reports_dir = CMDParser.jepArgPath(options.reports_dir)
        cov_dir = CMDParser.jepArgPath(options.cov_dir)
        return start_dir, reports_dir, cov_dir
